%{
    #include <stdio.h>
    void yyerror(const char *s);
    int yylex(void);
%}

%token PERSON PRIORITET VACCINERAT LISTA ALLA VACCINERADE OVACCINERADE AVSLUTA PERSONNUMMER HELTAL RADSLUT
%define parse.error verbose
%start inmatning

%%

inmatning : kommandolista avslutakommando;

kommandolista : kommando kommandolista | %empty ;

kommando : personkommando | prioritetskommando | vaccineratkommando | listakommando ;

personkommando : PERSON personlista RADSLUT;

prioritetskommando : PRIORITET HELTAL personlista RADSLUT;

vaccineratkommando : VACCINERAT personlista RADSLUT;

listakommando : LISTA ALLA RADSLUT | LISTA VACCINERADE RADSLUT | LISTA OVACCINERADE RADSLUT;

avslutakommando : AVSLUTA RADSLUT ;

personlista : PERSONNUMMER personlista | PERSONNUMMER ;

%%

int main() {
    printf("Mata in en inmatning. Avsluta med semikolon.\n");
    yyparse();
    printf("Klart!\n");
    return 0;
}

void yyerror(const char *s) {
    printf("Ogiltig inmatning! Felmeddelande: %s\n", s);
}

int yywrap(void) {
    return 1;
}
